<cfcomponent hint="File Explorer cfc" output="false">

    <!--- if this call is made via webservice --->
    <cfif IsSOAPRequest() OR NOT isDefined("variables.objectId")>
        <!--- makes sure the init gets called --->
        <cfset init() />
        <cfsetting showdebugoutput="false"/>
    </cfif>

	<!---Psuedo constructor--->
	<cfset variables.instance.defaultDirectory = "/opt/jrun4/servers/dev/cfusion.ear/cfusion.war">
	<cfset variables.instance.exclude = "Thumbs.db">
	<cfset variables.instance.filetypes = "jpg,png,txt,swf">

	<cffunction name="init" access="public" returntype="fileexplorer">
           <cfreturn this />
	</cffunction>

	<cffunction name="list" returntype="xml" access="remote">
		<cfargument name="path" type="string" default=""/>
		<cfargument name="filetypes" type="string" default="jpg,png,txt,swf,gif"/>
		<cfset var tresult = ""/>
		<cfset var result = ""/>		
		<cfset var prev = ""/>		
		<cfset var prevcount = 0/>		
		<cfset var prevtype = ""/>		
		<cfset var row = 0/>
		<cfset var loopcount = 1/>
		<!---<cfset var ext = ""/>
		<cfset var item = ""/>--->

		<cfset filetypes = variables.instance.filetypes & "," & filetypes/>
		
		<!---Fix Slashes--->
        <!---<cfset path = replace( path, "/", "\", "ALL") />--->

		<cfset path = variables.instance.defaultDirectory & "/" & path/>

		<!---<cfloop list="#filetypes#" index="item"><cfif len(ext)><cfset ext = ext & "|*.#item#"/><cfelse><cfset ext = "*.#item#"/></cfif></cfloop>--->		
		<cfdirectory action="list" directory="#path#" name="files" recurse="true">
		
		<cfquery name="qoq" dbtype="query">
		SELECT * from files
		<cfif ListLen(filetypes) eq 0 or filetypes eq "*.*">
		WHERE Type = 'File'
		<cfelse>
   		WHERE (<cfloop list="#filetypes#" index="ext">
				<cfif loopcount gt 1> or </cfif>name like '%.#ext#'
				<cfset loopcount = loopcount + 1>
				</cfloop>)
		</cfif>
		</cfquery>

		<!---Rebuilding Query to insert needed directory paths--->
		<cfset myQuery = QueryNew("Name, Directory, Type", "VarChar, VarChar, VarChar")>
		<cfset rowcount = 0>
		<cfset prev = path>

		<cfloop query="qoq">
		<cfif variables.instance.exclude does not contain name>

			<cfif directory gt prev>
					<!---Step back down until we find the directory path--->
					<cfset sdir = listtoarray(prev,"/")>
					<cfset sdirpath = prev>

					<cfloop from="#arraylen(sdir)+1#" to="1" step="-1" index="s">
						<cfif s lte arraylen(sdir)><cfset sdirpath = replace(sdirpath,"/"&sdir[s],"","ALL")></cfif>
						<cfif left(directory,len(sdirpath)) eq sdirpath and left(replace(directory,sdirpath,"","ALL"),1) eq "/">
							<cfif mid(replace(directory,sdirpath,"","ALL"),2,1) neq ":">
								<cfset prev = sdirpath>
								<cfbreak>
							</cfif>
						</cfif>						
					</cfloop>

				<cfset subdir = listtoarray(replace(directory,prev,"","ALL"),"/")>

				<cfloop from="1" to="#arraylen(subdir)#" index="s">
					<cfset addQueryRow(myQuery,subdir[s],prev,"Dir")>
					<cfset prev = prev & "/" & subdir[s]>
				</cfloop>
			</cfif>
			
			<cfset addQueryRow(myQuery,name,directory,type)>
			<cfset prev = directory>
			
		</cfif>
		</cfloop>

		<cfset result = queryToXML(myQuery,path)>
		<cfreturn result/>
	</cffunction>

	<cffunction access="public" name="addQueryRow" output="false" returntype="Query">
		<cfargument name="myQuery" type="Query" required="true"/>
		<cfargument name="name" type="string" required="true"/>
		<cfargument name="directory" type="string" required="true"/>
		<cfargument name="type" type="string" required="true"/>

		<cfset QueryAddRow(myQuery, 1)>
		<cfset QuerySetCell(myQuery, "Name", name, myQuery.recordcount)>
		<cfset QuerySetCell(myQuery, "Directory", directory, myQuery.recordcount)>
		<cfset QuerySetCell(myQuery, "Type", type, myQuery.recordcount)>
	
		<cfreturn myQuery/>
	</cffunction>

	<cffunction access="public" name="queryToXML" output="false" returntype="xml">
		<cfargument name="myQuery" type="Query" required="true"/>
		<cfargument name="path" type="String" required="true"/>
		<cfset var prev = path/>
		<cfset var result = "<root>">
		<cfset var urlPath=""/>
		<cfset var sdir=""/>
		<cfset var sdirpath=""/>
		
		<cfloop query="myQuery">
			<cfset urlPath = replace(replace(directory,variables.instance.defaultDirectory&"/","","ALL"),"\","/","ALL")>
			<cfif type eq "File">
				<cfif prev neq directory>
					<!---Going Down--->
					<cfset sdir = listtoarray(prev,"/")>
					<cfset sdirpath = prev>

					<cfloop from="#arraylen(sdir)#" to="1" step="-1" index="s">
						<cfset sdirpath = left(sdirpath,len(sdirpath)-(len(sdir[s])+1))/>
						<!---<cfset sdirpath = replace(sdirpath,"\"&sdir[s],"","ALL")>--->
						<cfset result &= "</item>">
						<cfif sdirpath eq directory or sdirpath eq path><cfbreak></cfif>
					</cfloop>
				</cfif>
				<cfset result &= "<item name=""#name#"" directory=""#urlPath#"" type=""#type#""></item>">
				<cfset prev = directory>
			<cfelseif type eq "Dir">
				<cfif directory eq prev>
					<!---Climbing--->
					<cfset prev = directory & "/" & name>
				<cfelse>
					<!---Going Down--->
					<cfset sdir = listtoarray(prev,"/")>
					<cfset sdirpath = prev>

					<cfloop from="#arraylen(sdir)#" to="1" step="-1" index="s">
						<cfset sdirpath = left(sdirpath,len(sdirpath)-(len(sdir[s])+1))/>
						<!---<cfset sdirpath = replace(sdirpath,"\"&sdir[s],"","ALL")>--->
						<cfset result &= "</item>">
						<cfif sdirpath eq directory or sdirpath eq path><cfset directory = sdirpath><cfbreak></cfif>
					</cfloop>
					
				</cfif>
				<cfset result &= "<item name=""#name#"" directory=""#urlPath#"" type=""#type#"">">
				<cfset prev = directory & "/" & name>
			</cfif>
		</cfloop>

		<cfif prev neq path>
			<!---Going Down--->
			<cfset sdir = listtoarray(prev,"/")>
			<cfset sdirpath = prev>

			<cfloop from="#arraylen(sdir)#" to="1" step="-1" index="s">
				<cfset sdirpath = left(sdirpath,len(sdirpath)-(len(sdir[s])+1))/>
				<!---<cfset sdirpath = replace(sdirpath,"\"&sdir[s],"","ALL")>--->
				<cfset result &= "</item>">
				<cfif sdirpath eq path><cfset directory = sdirpath><cfbreak></cfif>
			</cfloop>
		<cfelse>
			<!---<cfset result &= "</item>">--->
		</cfif>

		<cfset result &= "</root>">

		<cfif result eq "<root></item></root>"><cfset result = "<root/>"></cfif>

		<cftry><cfset result = xmlParse(result)>
			<cfcatch>
				<cfset result = "<root/>">
				<cfset result = xmlParse(result)/>
				<cfdump output="console" var="XML Parse error - file explorer cfc">
			</cfcatch>
		</cftry>

		<cfreturn result/>
	</cffunction>

</cfcomponent>
